
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>打造云上代码交付链，CodePipeline实践分享 / iVAN</title>

    <meta name="description" content="打造云上代码交付链，CodePipeline实践分享 在2017在线技术峰会--首届阿里巴巴研发效能嘉年华上,来自阿里云飞天研发部的工程师莫源分享了&lt;打造云上代码交付链,CodePipeline实践分享&gt;.他在云计算和云平台.持续集成流程.DevOps的基础上,详细分享了Alibaba Cloud CodePipeline优于Jenkins的性能和实践. 以下内容根据直播视频整理而成. 直播视频:https://yq.aliyun.com/edu/lesson/549 PDF下载:https://yq.aliyun.com/attach ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">打造云上代码交付链，CodePipeline实践分享</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>在2017在线技术峰会——首届阿里巴巴研发效能嘉年华上，来自阿里云飞天研发部的工程师莫源分享了《打造云上代码交付链，CodePipeline实践分享》。他在云计算和云平台、持续集成流程、DevOps的基础上，详细分享了Alibaba Cloud CodePipeline优于Jenkins的性能和实践。</p>
<p>以下内容根据直播视频整理而成。</p>
<p><b>直播视频：</b></p>
<p><b>PDF下载：</b>https://yq.aliyun.com/attachment/download/?id=1844</p>
<h1><b>云计算和云平台</b></h1>
<p>云计算领域和其他领域是非常相似的，当一个领域越来越成熟的时候，发展方向会朝着精细化发展。比如，ofo解决了如何脱离城市公共交通之外解决最后一公里的问题。云计算也越来越成熟，上云解决了基础设施交付的问题，但是对于开发者而言还远远不够，云原生架构设计与应用成为了云计算的“最后一公里”问题。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzExYTE5NDc0NDFiYWZhYWIyODEyZWI2YjIxOGJlYjI3MTliOTA2M2UucG5n.jpg"></p>
<p>上图是NETFLAG公司定义的Cloud Native架构设计图。主要分为三个部分：Framework（左边），推荐使用微服务架构；Container Runtime（右边），建议容器化、资源生命周期自动化；Infrastructure Automation（中间），表达了基础设施即代码的思想，以及配管运维自动化。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzdiOTk5Y2UwMmJmOTY5MWY2MTlkYWFhNGM2NWFmMmNlNDM5NTZjMzMucG5n.jpg"></p>
<p>把刚才的图转换一下，可以总结为四个要点：DevOps、Continuous Delivery、Microservices、Containers。但对于开发者来讲，微服务和容器并不是必须的，而是与自己的模型、编程框架相关的，而DevOps和持续集成则是通用的模型。作为一个云计算厂商，我们要解决的是开发者如何在通用模型之下解决自己的问题。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzc2NmM1MDdlMGYxMzQ5Y2VhZDE5ZjdiYmU5NjRlZjgzZGQ5YTBjYWYucG5n.jpg"></p>
<p>上图大家都比较熟悉，讲述了云平台的SaaS、PaaS、IaaS层。最底层是IaaS层，提供了资源，PaaS层提供了能力，而SaaS层提供了服务。金字塔最底层是最扎实的，越往上越小，而DevOps是塔尖。所以，只有最底层基础设施的环境变得十分稳固、厚重的时候，才能保证最上层的DevOps有一个更高效的能力。</p>
<h1><b>持续集成流程</b></h1>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2E4YWJiMTc5NzUyNjg0MTk4ZjM0NDVhODk2MDcwOWI3NTZmNTExMzYucG5n.jpg"></p>
<p>常见的DevOps流程分为代码开发，提交代码到代码仓库，通过web hook触发，由持续集成系统分别部署到测试环境、预发环境、正式环境。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzU0MGJmYWEyMjNkYWE3NTM3OGVlZDY4YzM4Y2ZlODRmZTcwZTgwZDUucG5n.jpg"></p>
<p>上图是基于容器的持续集成流程图。和前图的区别在于，在持续集成系统上层有一个镜像仓库，持续集成系统会把镜像推到镜像仓库，部署的时候由部署环境拉取镜像进行部署。</p>
<h1><b>DevOps</b></h1>
<p>DevOps不是让你成为全能忍者，而是消除“等待”与“浪费”。传统的瀑布流开发模型分为很多阶段：需求分析、设计、实现、验证、运维，这个过程中我们会等待基础架构的设计、应用程序部署、其他团队或者审核流程。而DevOps可以帮助消除不必要的流程、特性、人工、返工。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2VkMzUxZDk2NWJlMTA1NjQwYmE3ZGM4ZjYwOTMzNWY3MzZiMzMwZWQucG5n.jpg"></p>
<p>DevOps核心思想是分而治之，连续集成，快速交付。以前软件开发、交付的生命周期很长，以月或者半年为单位，现在将生命周期进行切分，变成以周或者天为单位。为什么以前没有做到？因为以前很难做到整个流程的自动化，比如基础设施自动化、交付自动化等，而现在云计算给了我们这个能力。Cloud Native、Microservices、Docker、Serverless是和DevOps结合最紧密的四个领域。这些领域展现了软件架构的变革，软件的架构变革带来了灵活性、稳定性、功能性也带来了技术成本。比如，Docker解决了如何快速交付的流程但是解决不了学习Docker的成本、运维的成本。DevOps解决的是如何将上述四个领域的技术成本屏蔽，通过自动化的方式把很多技术的问题变成按钮点击的问题。所以，DevOps的本身不是一个技术问题，但是技术的变革需要DevOps来填平带来的技术成本。DevOps实现是一个适配器，封装了本地开发与远程交付之间的实现。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzBmYjAyNGU0ZTJjNDk4YzYxYmY5OTNjN2VmZWIxM2YyMGU0NDFmMzYucG5n.jpg"></p>
<p>DevOps里最核心的是持续集成服务器，它是交付流程的发动机。用的最多的持续集成服务器是Jenkins，每个阶段Jenkins都可以和很多系统集成，但是它也存在一些问题：架构陈旧，性能低下，单个Jenkins在并发1000个job或者250个slave的时候就会出现很严重的性能问题；安全漏洞很多，Master、插件都有很多漏洞；独立运维成本很高，Jenkins本身是Java的应用，但是还涉及到slave pool、镜像、配置插件等；缺乏完善的权限模型，使用权限模型的时候没法和namespace脱开；通用的DevOps模型需要更多的集成；插件太多导致缺乏最佳实践经验。</p>
<h1><b>Alibaba Cloud CodePipeline</b></h1>
<p>Alibaba<br />
Cloud CodePipeline是一个SaaS化的持续集成引擎。通过可视化的配置，简单快捷地实现持续集成与持续交付的流程，完全兼容Jenkins，并且在Jenkins上做了很多增强。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2I1YzQ3OTFjNjhmOWQyZWE5N2E4Y2VkMjdjNDE0Y2ZkMmMxMTU1MTEucG5n.jpg"></p>
<p>上图是Alibaba Cloud CodePipeline的基础结构图。CodePipeline<br />
Service是任务调度系统，它会把任务分配到任务沙箱式运行时环境资源池，资源池是弹性伸缩的，开发者使用CodePipeline的时候无须担心自己的任务有多少、并发有多少。构建任务完成、代码下发好之后会发布一条部署命令，部署命令是由Deploy Service来完成的，它是通过反打方式实现的，好处是无须担心用户的网络环境。右侧是部署环境，支持ECS、HPC、VM、阿里云的Container Service。</p>
<h2><b>SaaS</b><b>化持续交付引擎</b></h2>
<p>SaaS化的好处是：无需运维，开箱即用，使用云账号登陆即可拥有免费使用额度，独立部署支持与企业现有的LDAP集成，内置多种常用必备插件，无需二次安装；资源按需使用，动态生成，按使时长和资源付费，无需担心资源容量（公测不收费），资源动态使用动态销毁，无需担心代码、构建物外泄，资源无需运维，平台资源池统一维护，资源秒级生成、秒级销毁。</p>
<h2><b>全量兼容Jenkins插件</b></h2>
<p>CodePipeline对Jenkins插件进行了安全加固，所有开放出来的插件都经过安全加固，加固后的插件不定期的反馈给社区。并且根据开发者需求不断开放Jenkins插件满足开发者的需求。开发者可以根据需求提交开放申请，内置的Best<br />
Practise会提供更多场景的插件组合的使用方案，开放的插件的能力会在阿里云的场景下有更多的集成。</p>
<h2><b>阿里云产品生态无缝集成</b></h2>
<p>集成OSS、容器Hub存储构建物，OSS提供构建物存储，Hub提供镜像存储，未来考虑支持（Nas等等）。支持多种部署环境，包括ECS支持标准应用部署、容器支持容器化部署、EGS、ESS、EWS等等。</p>
<h2><b>多种部署方式支持</b></h2>
<p>支持跨Region部署（经典、VPC)，具备IDC、公有云、跨云混合部署的能力，VPC网络采用反向通道的方式，无需在安全组上打洞。支持多种部署方式，具备ECS、容器服务混合部署，支持不同部署环境跨Region部署，支持部分部署模型的无宕机发布。支持全量的部署环境，公测版本支持Java、Node.js的环境，预计短期开放PHP、Python、Go、C++等语言。</p>
<h2><b>内置最佳实践</b></h2>
<p>向导方式内置语言的部署最佳实践，公测支持Java与Node.js，支持用户自定义最佳实践（待开放）。社区、论坛提供最佳实践的文章与指南，提供基础功能的使用指南，提供标准流程的最佳实践指南，提供高级功能扩展使用实践。</p>
<h1><b>Reference</b></h1>
<p>Terraform阿里云官方github仓库：<a href="https://github.com/alibaba/terraform-provider" rel="external nofollow noreferrer">https://github.com/alibaba/terraform-provider</a></p>
<p>Packer阿里云官方github仓库：<a href="https://github.com/alibaba/packer-provider" rel="external nofollow noreferrer">https://github.com/alibaba/packer-provider</a></p>
<p>阿里云针对于开源DevOps工具的github仓库总入口链接：<a href="https://github.com/alibaba/opstools" rel="external nofollow noreferrer">https://github.com/alibaba/opstools</a></p>
<p>阿里云DevOps系列文章与Jenkins持续集成解决方案：<a href="https://github.com/AliyunContainerService/DevOps" rel="external nofollow noreferrer">https://github.com/AliyunContainerService/DevOps</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-14 10:35:03</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9e%b6%e6%9e%84/" title="架构">架构</a>, <a href="https://www.iamivan.net/tag/%e9%98%bf%e9%87%8c%e4%ba%91/" title="阿里云">阿里云</a>, <a href="https://www.iamivan.net/tag/%e4%ba%91%e5%b9%b3%e5%8f%b0/" title="云平台">云平台</a>, <a href="https://www.iamivan.net/tag/https/" title="HTTPS">HTTPS</a>, <a href="https://www.iamivan.net/tag/%e9%95%9c%e5%83%8f/" title="镜像">镜像</a>, <a href="https://www.iamivan.net/tag/%e5%ae%b9%e5%99%a8/" title="容器">容器</a>, <a href="https://www.iamivan.net/tag/%e4%ba%91%e8%ae%a1%e7%ae%97/" title="云计算">云计算</a>, <a href="https://www.iamivan.net/tag/%e5%9f%ba%e7%a1%80%e8%ae%be%e6%96%bd/" title="基础设施">基础设施</a>, <a href="https://www.iamivan.net/tag/%e5%be%ae%e6%9c%8d%e5%8a%a1/" title="微服务">微服务</a>, <a href="https://www.iamivan.net/tag/cloud/" title="Cloud">Cloud</a>, <a href="https://www.iamivan.net/tag/%e6%8c%81%e7%bb%ad%e9%9b%86%e6%88%90/" title="持续集成">持续集成</a>, <a href="https://www.iamivan.net/tag/devops/" title="devOps">devOps</a>, <a href="https://www.iamivan.net/tag/%e6%8c%81%e7%bb%ad%e4%ba%a4%e4%bb%98/" title="持续交付">持续交付</a>, <a href="https://www.iamivan.net/tag/codepipeline/" title="CodePipeline">CodePipeline</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>打造云上代码交付链，CodePipeline实践分享的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Zv7Dz.html" rel="bookmark">云上持续交付实践系列3 --- Python 篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				云上持续交付实践系列3 --- Python 篇 阿里云持续交付平台CRP(Continuous Release Platform)作为一款开发人员手里的居家旅行,杀人越货的利器,必然有其广泛的应用场景.本文将会演示如何在如何使用阿里云持续交付平台部署一个Python应用.Python作为一种脚本语言,经常与多种语言一起配合完成某些复杂的功能,与此同时,其强大的第三方库又进一步拓展了Python的应用领域. 应用概述 本文涉及两个项目,分别为基于Python的在线爬虫以及基于node.js的we			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK5NxEp.html" rel="bookmark">云上持续交付实践系列5 --- Ruby 篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文会演示如何在CRP上编译并部署一个Ruby应用. 相关技术栈和用到的网站 本文将以ruby-china为例,使用CRP平台实现该项目的编译.测试和最终部署. 1. Rails作为Web框架 2. Postgres作为数据库存储 3. Memcached作为分布式内存对象缓存系统 4. Redis作为Key-Value数据库 5. Elasticsearch则作为一个简单的搜索引擎 本次实践中为了更好地使用代码库服务,我们将ruby-china的代码迁移到了阿里云Code中,在Gemfile里			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDXdXrz.html" rel="bookmark">打造云上深度学习实验室</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				云栖TechDay36期,来自阿里云技术专家必嘫带来题为&quot;打造云上深度学习实验室&quot;的演讲.本文主要从深度学习流程开始谈起,解释了深度学习应用构建的完整生命周期,进而分享了机遇与容器服务的深度学习解决方案架构,接着讲解了端到端的深度学习体验,最后作了简要总结.以下是精彩内容整理:   深度学习流程 目前,人工智能已经进入了深度学习时代, 利用GPU加上深度学习理论,构建了一个模型,从2010年开始ImageNet所有技术都是基于传统机器视觉技术来做的,当时的识别率最好也差不多是在75%左			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVaZDYp.html" rel="bookmark">加快打造&OpenCurlyDoubleQuote;云上贵州&rdquo;&comma;靠大数据实现&OpenCurlyDoubleQuote;后发赶超&rdquo;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&quot;把大数据作为全省弯道取直.后发赶超的战略引擎,充分挖掘利用其商业价值.管理价值.社会价值,以大数据提升政府治理能力,引领产业转型升级,服务广大社会民生,带动大众创业.万众创新.&quot;26日,在贵州省十二届人大四次会议开幕式上,贵州省代省长孙志刚在做政府工作报告时说. 经过近两年的实践探索,贵州大数据产业规模总量已超过5000亿元,年均增长20%以上,成为新的支柱产业.全新的发展模式,正在培育贵州经济发展&quot;新动能&quot;,为同步小康插上&quot;翅膀&quot;. 截至20			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOJvmqp.html" rel="bookmark">蒋帆：区块链落地实践分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是蒋帆:区块链落地实践分享 分享主题:区块链落地时的问题域和主要实践方法,如&quot;区块风暴工作坊&quot;.&quot;区块链的敏捷开发与Devops实践&quot;.&quot;内建安全的区块链应用&quot;等关键活动. 讲师介绍:蒋帆,Fabulous J,ThoughtWorks高级咨询师,在北京与厄瓜多尔,从事信息安全与隐私加密协议研发,熟悉密码学.数字货币与网络通讯协议等领域. 分享内容如下:1.ThoughtWorks 在中国区为客户提供的区块链服务 2.Blockchain			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6enQNb.html" rel="bookmark">空格App亿元A轮融资背后：云上多场景技术架构实践与经验</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				直播视频: (点击图片观看) 幻灯片下载地址: https://oss.aliyuncs.com/yqfiles/382bc642fc0b621a9368138a74d8fd36.pdf 阿里云在空格   图一 空格服务端整体架构   在空格初始创业阶段,人员十分缺乏,但依靠着阿里云,空格两周便实现APP上线.空格服务端整体架构包括在线和离线两大部分.在线服务端的前端包括用户服务端集群.商家服务端集群和IM PUSH集群:在线服务端的后端由搜索/推荐引擎集群组成:架构底层的存储采用传统的MySQ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mydg5Jb.html" rel="bookmark">阿里巴巴拿下奥委会顶级赞助商！中国力量打造&OpenCurlyDoubleQuote;云上的奥运&rdquo;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1月19日,国际奥林匹克委员会与阿里巴巴集团在瑞士达沃斯联合宣布,双方达成期限直至2028年的长期合作. 阿里巴巴将加入奥林匹克全球合作伙伴(The Olympic Partner,&quot;TOP&quot;)赞助计划,成为&quot;云服务&quot;及&quot;电子商务平台服务&quot;的官方合作伙伴,以及奥林匹克频道的创始合作伙伴. 通过签约国际奥委会顶级赞助商,阿里巴巴将为奥运会提供一流的云计算和大数据基础设施及服务,给世界带来第一届&quot;云上的奥运&quot;. &quot;TOP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9xlXRb.html" rel="bookmark">云上持续交付实践系列4 --- node 篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文会演示如何在CRP上编译并部署一个Node应用. 相关的技术和网站 阿里云持续交付平台 https://crp.aliyun.com 阿里云Code https://code.aliyun.com crp提供的编译能力 现在crp平台已经支持node0.12,node4.4.x, node5.9.x 版本的项目编译/测试 常用的node编译指令和环境 1.常用的node相关的指令 npm install //安装依赖 npm list //列举已经安装的依赖 npm test //执行测试			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyWjlEz.html" rel="bookmark">云上持续交付实践系列2--- go篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				go 作为一门google 开发的语言最近是越来越火了,其具备清晰.并行.安全等优点.当下非常流行的docker就是用go 语言的编写的.阿里云持续交付平台最近推出了多语言编译的支持,其中就包括go.本文就拿github 上开源的纯go 语言项目gogits/gogs 来小尝牛刀. 项目介绍 gogs 是github 上开源的用go 编写的轻量级的git 服务器.相比于现有开源的gitlab, 它更加的灵活.轻量.跨平台,很适合小型的开发团队.项目主页的地址:https://gogs.io/ 准			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDA9lb.html" rel="bookmark" class="title">HTML彻底剖析&lpar;2&rpar;标记一览</a>
					<div>
						标记 类型 名称或意义 作用 备注 文件标记 &lt;HTML&gt; ● 文件宣告 让浏览器知道这是 HTML 文件   &lt;HEAD&gt; ● 开头 提供文件整体信息   &lt;TITLE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boRjBz.html" rel="bookmark" class="title">POJ 1474 半面相交</a>
					<div>
						题意:给定一个多边形判断是否存在内核. 模板题.判断最后半面相交的半面数至少3个就行. #include&lt;cmath&gt; #include&lt;cstdio&gt; #include&lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPW2AM.html" rel="bookmark" class="title">用PHP实现文件上传二法</a>
					<div>
						上传 PHP(Hypertext Preprocessor)是一种 HTML 内嵌式的语言 (类似 IIS 上的ASP).而 PHP 独特的语法混合了 C.Java.Perl 以及 PHP 式的新语法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgdN3p.html" rel="bookmark" class="title">js取得cookie值的函数</a>
					<div>
						由于asp的cookie是经过url编码的,所以读之前要unescape一下. 下面是我用正则的方法取cookie,包括单值和多值: /******************************** ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJo4Jb.html" rel="bookmark" class="title">谈百度处罚不相关静态搜索结果页的思考</a>
					<div>
						&quot;百度网页搜索反作弊团队近期发现一部分网站遍历热门关键词生成大量的站内搜索结果页来获取搜索引擎流量,其中存在大量的不相关内容严重损害了搜索引擎的用户体验并且侵占了相应领域的优质网站收益,对于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdQgXz.html" rel="bookmark" class="title">关于打击超链作弊几大疑问</a>
					<div>
						对于23日百度发出的&lt;关于超链作弊的算法升级&gt;的公告,我相信很多人都认真的研究了,因为每次百度算法的升级都深深地影响着我们这些草根站长,如果我们忽视一点,很可能等待我们的是K站,之前的努力 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVxRQM.html" rel="bookmark" class="title">从 &period;NET 程序集提供图像&lpar;二&rpar;</a>
					<div>
						程序 目录:增强代码整理安全性小结关于作者 增强代码 代码中首先要处理的是大小写形式.HTTP 认为以下所有 URL 都相同,因为 URL 不区分大小写. &lt;img src=http://www ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2Ql3z.html" rel="bookmark" class="title">360用自家的产品打败了自己的360搜索</a>
					<div>
						离360搜索横空出世的时间差不多快一个月了,想当初360搜索刚推出来的时候和现在对比起来用冰火二重天来形容一点也不为过.当360搜索刚出来,然后第二天铺天盖地新闻都是360搜索一举打败谷歌,搜狗,搜搜 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b33ykb.html" rel="bookmark" class="title">企业网站优化策略详解</a>
					<div>
						对于真正懂SEO的人来说,都会知道,不同的网站,运用的网站优化方法是不一样的,必须针对这个行业的性质指定最适合的优化策略,所以因地制宜,应人而授便是这个道理. 企业网站由于其特殊性,所以其优化的方法较 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1WB7z.html" rel="bookmark" class="title">如何配置AIX的磁盘限额</a>
					<div>
						操作系统版本: testterm1:/#oslevel -r 5300-00 磁盘限额系统,它基于Berkeley磁盘限额系统,提供了控制使用磁盘空间的有效方式.为个人用户或组定 义限额系统,并且为每 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4w54Pp.html" rel="bookmark" class="title">在Web Service中使用Windows验证的方式</a>
					<div>
						很多朋友都知道在Web Service中支持Windows验证.但其实能用好的朋友并不 是特别多,因为有几个特殊之处需要注意 1.在服务端如何配置 这里要注意的是,authentication的mod ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2yO7M.html" rel="bookmark" class="title">Photoshop制作微缩景观图片</a>
					<div>
						喜欢摄影的朋友都知道,在拍摄细小及微观物体的时候如花朵,蜜蜂等,我们把光圈调得特别大.这样拍出的片子焦距很小.主体前后都会模糊.下面的教程正是用PS来模拟这种效果. 原图 最终效果 1.选择照片运行p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7OvNM.html" rel="bookmark" class="title">事件处理-新手求教大神，java事件监听问题</a>
					<div>
						问题描述 新手求教大神,java事件监听问题 import java.awt.FlowLayout; import java.awt.event.ActionEvent; import java.aw ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPP6BZp.html" rel="bookmark" class="title">让 Ghost 不通过加载 js 文件来实现代码高亮</a>
					<div>
						我们添加代码高亮一般都是+css +js来实现的,不过么我们既然是使用 Ghost,基于 Node.js ,我们在后台用 Markdown 书写内容,然后 Ghost 将 markdown 转为 ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWr2yp.html" rel="bookmark" class="title">TTserver遍历所有数据时遇到当中有key为null的情况？</a>
					<div>
						问题描述 TTserver遍历所有的key时,遇到当中一条数据key为null,此时服务做什么样的处理?从TTserver提供的测试源码中看到,如果遍历到一个key为null的时候,跳出循环不再继续遍 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQqOqp.html" rel="bookmark" class="title">gbk编码-在线等！&period;net  GBK编码问题</a>
					<div>
						问题描述 在线等!.net GBK编码问题 Encoding encoding = null; encoding = Encoding.GetEncoding(&quot;GBK&quot;); 为什 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEjYap.html" rel="bookmark" class="title">请问String tb，这个&amp;amp&semi;amp&semi;quot&semi;&plus;tb&plus;&amp;amp&semi;amp&semi;quot&semi;是什么类型</a>
					<div>
						问题描述 如题 解决方案 解决方案二:如题不明白~解决方案三:那是字符串拼接不是类型!解决方案四:不贴出来谁知道你说什么.估计你说的是拼SQL语句的事.解决方案五:stringsql=&quot;in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmRGAb.html" rel="bookmark" class="title">用例子测试juddi时出现的问题请大家帮忙了，好几天了，没有任何进展！ 请大家帮帮忙吧！</a>
					<div>
						问题描述 ***********RunningSaveBusinessExample***********GetauthtokenExceptioninthread&quot;main&quot;ja ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKvKab.html" rel="bookmark" class="title">暴力枚举Gmail邮箱地址的新姿势</a>
					<div>
						本文讲的是暴力枚举Gmail邮箱地址的新姿势, 本文将介绍一种比较经典的枚举用户Gmail邮箱地址的新思路,这种思路可以检索成千上万个Gmail邮箱地址. 我偶然发现一个小故障,允许我大量猜测现有的且 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZB2j5z.html" rel="bookmark" class="title">Ping延时测试报告：你的WAN链路有多慢</a>
					<div>
						ICMPPing测试如何工作Ping是专用IP网络工具,Ping发送一个ICMP回声请求消息给目的地并报告是否收到所预期的ICMP回声应答.各个操作系统 都有安装Ping工具,任何常见的企业平台,像W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAEXkeM.html" rel="bookmark" class="title">整合 java &plus; BlazeDS &plus; spring &plus; JDO 部署到 app 上&period;</a>
					<div>
						先看到 一篇 部署到 app 上面的文章. http://www.iteye.com/topic/428326   感谢这个兄弟的研究.       先说昨天写的一篇 文章.   http://toe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvnd49M.html" rel="bookmark" class="title">联想称已占中国PC市场份额32&percnt;</a>
					<div>
						本报讯(记者牛颖惠)昨天下午,联想集团公布截至2010年12月31日第三季度(Q3)业绩.报告期内,联想集团销售额为58.08亿美元,同比上升22%,净利润1.27亿美元, 同比增长28%.与此同时, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgZKvM.html" rel="bookmark" class="title">山东鲁能&lowbar;发改委-光伏扶贫信息化项目Bug修改</a>
					<div>
						写这篇博客的原因就是这也算是本人第一次修改比较大的Bug,所以对以后的工作肯定有百利而无一害. 最开始肯定要看清版本号(特别注意小版本号,因为大版本可能是通用版,很多产品都是定制的) 如果没看清版本号 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqEJ7p.html" rel="bookmark" class="title">计算一个Java对象占用字节数的方法&lowbar;java</a>
					<div>
						本文实例讲述了如何计算(或者说,估算)一个Java对象占用的内存数量的方法.分享给大家供大家参考.具体分析如下: 通常,我们谈论的堆内存使用的前提是以&quot;一般情况&quot;为背景的.不包括下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNa0Bp.html" rel="bookmark" class="title">ipad&sol;ipad2&sol;ipad air&sol;ipad min平板iOS8&period;1&period;1降级iOS8&period;1教程</a>
					<div>
						方法一:官方恢复 降级说明: 此方法适用于在最新 iOS8.1 系统验证未关闭的时候操作 操作步骤: 1.将iphone ipad iTouch 等设备连接电脑打开 iTunes. 2.按住键盘上 S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgP468p.html" rel="bookmark" class="title">iPhone 6后置摄像头曝光 集成光学防抖功能</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 iPhone 6主镜头(左 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVdVjBM.html" rel="bookmark" class="title">伊利奶牛学校：乳业知识的普及者</a>
					<div>
						2012年11月初,伊利奶牛学校举办第二届高级牧场管理培训班.通过理论课程与生产实践两大环节,来促进学员将理论知识与动手实践相结合,以此提升了伊利牧场的养殖管理水平.其实,在不久前的2012年6月,伊 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx2aAGz.html" rel="bookmark" class="title">【5&period;15北京】&period;NET不一样了，让你一统三国！</a>
					<div>
						问题描述 通过Xamarin开发套件,你将可以用VisualStudio及C#开发各移动平台(Windows/iOS/Android)的App,而且执行效能一样好!让使用.NET技术开发企业应用者,用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwy3eWM.html" rel="bookmark" class="title">《Effective Ruby：改善Ruby程序的48条建议》一第13条：通过&amp;quot&semi;&amp;lt&semi;&equals;&amp;gt&semi;&amp;quot&semi;操作符实现比较和比较模块</a>
					<div>
						第13条:通过&quot;&lt;=&gt;&quot;操作符实现比较和比较模块 在第12条中提到了四种测试对象相等性的方法.如果你对对象的排序和比较有兴趣,那么你就需要进一步定义其他的比较操作符了. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQW0JQp.html" rel="bookmark" class="title">DELPHI XE2马上推出</a>
					<div>
						DELPHI XE2马上推出 将是一场技术革命 DELPHI XE2 马上要推出了,那将是一场技术革命!支持64位开发,移动平台开发,web开发等等...今天参加了Delphi XE2的产品发布会,趁 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
